Bug 1127510

Summary: Restart & Install restarts but does not install
Product: [Fedora] Fedora Reporter: Chris Murphy <bugzilla>
Component: PackageKitAssignee: Richard Hughes <rhughes>
Status: CLOSED CURRENTRELEASE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 21CC: bugzilla, johannbg, jonathan, kalevlember, lnykryn, msekleta, rdieter, rhughes, robatino, smparrish, s, systemd-maint, vpavlin, zbyszek
Target Milestone: ---   
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2014-09-21 10:38:00 UTC Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On:    
Bug Blocks: 1043124    
Attachments:
Description Flags
journalctl -b -l -o short-monotonic
none
journalctl -b -l -o short-monotonic, systemd dracut debug none

Description Chris Murphy 2014-08-07 02:44:31 UTC
Created attachment 924690 [details]
journalctl -b -l -o short-monotonic

Description of problem: Software informs me there are two updates available. I click the Restart & Install button, the system restarts but nothing is installed, and upon launching Software the same two updates are still present.


Version-Release number of selected component (if applicable):
gnome-software-3.13.4-2.fc21.x86_64


How reproducible:
Always


Steps to Reproduce:
1. Click Restart & Install
2.
3.

Actual results:

System restarts, no installation occurs. Software continues to list available updates.

Expected results:

Restart, installation of updates, another restart. 

Additional info:
I'm not sure what triggers (systemd?) the update, so I'm attaching the entire journal for the boot immediate after clicking Restart & Install, the one that should have installed the updates. Could be useless.

Comment 1 Chris Murphy 2014-08-08 01:13:28 UTC
Created attachment 925047 [details]
journalctl -b -l -o short-monotonic, systemd dracut debug

Disabled NetworkManager debugging. Enabled rd.debug and systemd.log_level=debug.

This looks suspicious:

[   18.139218] twenty1.localdomain systemd[1]: Starting of systemd-update-done.service requested but condition failed. Ignoring


[root@twenty1 Downloads]# systemctl status systemd-update-done.service
● systemd-update-done.service - Update is Completed
   Loaded: loaded (/usr/lib/systemd/system/systemd-update-done.service; static)
   Active: inactive (dead)
           start condition failed at Thu 2014-08-07 18:46:29 MDT; 19min ago
     Docs: man:systemd-update-done.service(8)


-rw-r--r--. 1 root root        0 Aug  4 05:33 .updated


OK so yeah the update hasn't happened. But what's supposed to trigger the update? Either gnome-software isn't setting the trigger or systemd isn't honoring it. I suspect the latter because when I reboot from the far right pull-down menu to reboot, I get a floating dialog asking me if I want to install pending software updates; choosing that results in the same behavior: no update. So it's not just gnome-software. Seems like systemd isn't picking up the ball.

Comment 2 Chris Murphy 2014-08-08 01:40:35 UTC
http://freedesktop.org/wiki/Software/systemd/SystemUpdates/

OK I'm following steps 1-4, but I get lost in between the system update script being run, which it appears not to be, and the part about taking a Btrfs snapshot which is definitely not done. Looking like this is a systemd bug.

system-update -> /var/cache exists.

I don't know why it takes three spawnings, but the generator is spawned.

[    5.400116] twenty1.localdomain systemd[419]: Spawned /usr/lib/systemd/system-generators/systemd-system-update-generator as 435.
[    5.521078] twenty1.localdomain systemd[419]: /usr/lib/systemd/system-generators/systemd-system-update-generator succeeded.
[ 1115.653073] twenty1.localdomain systemd[2778]: Spawned /usr/lib/systemd/system-generators/systemd-system-update-generator as 2789.
[ 1115.660969] twenty1.localdomain systemd[2778]: /usr/lib/systemd/system-generators/systemd-system-update-generator succeeded.
[ 1135.463663] twenty1.localdomain systemd[2808]: Spawned /usr/lib/systemd/system-generators/systemd-system-update-generator as 2819.
[ 1135.469640] twenty1.localdomain systemd[2808]: /usr/lib/systemd/system-generators/systemd-system-update-generator succeeded.

[root@twenty1 /]# systemctl status default.target
● system-update.target - System Update
   Loaded: loaded (/usr/lib/systemd/system/system-update.target; static)
   Active: inactive (dead)
     Docs: http://freedesktop.org/wiki/Software/systemd/SystemUpdates
           man:systemd.special(7)
           man:systemd-system-update-generator(8)




systemd-215-8.fc21.x86_64

Comment 3 Chris Murphy 2014-08-18 04:50:52 UTC
Still a problem with these versions:
gnome-software-3.13.5-0.1.git5c89189.fc21.x86_64
systemd-215-11.fc21.x86_64

Proposing as beta blocking: The installed system must be able to download and install updates with the default graphical package manager in all release-blocking desktops.
http://fedoraproject.org/wiki/Fedora_21_Beta_Release_Criteria#Updates

Comment 4 Kalev Lember 2014-09-20 13:22:00 UTC
Can you retest with PackageKit-1.0.0-2.fc21 and gnome-software-3.13.92-2.fc21, please? These releases had a number of fixes that should improve the reliability of offline updates.

Thanks!

Comment 5 Chris Murphy 2014-09-21 03:11:41 UTC
Appears fixed in Fedora-Live-Workstation-x86_64-21_Alpha-1.iso which use:
PackageKit-0.9.5-1.fc21
gnome-software-3.13.91-1.fc21
systemd-215-11.fc21

Both restarting from gnome-software and gnome-shell restart/poweroff dialog result in an updated system, and no post-install confusion whether there are still pending updates.

Comment 6 Kalev Lember 2014-09-21 10:38:00 UTC
Excellent, thanks for testing!